## hugs98 98.200609.21

=== Makefile ===
# Top-level Makefile for Hugs
# (this should be a POSIX 1003.2-1992 Makefile)

# Start of general settings (leave this line unchanged)

NAME = hugs98

# Set to 0 if a snapshot release.
MAJOR_RELEASE = 1

# Release number of RPM.
RELEASE = 1

TAG = HEAD
HSLIBSTAG = HEAD

CVS_ROOT = :pserver:anoncvs@cvs.haskell.org:/cvs
HSLIBSDIRS = concurrent data hssource lang net text util posix

DARCS_ROOT = http://darcs.haskell.org
LIBRARIESDIRS = base haskell98 haskell-src mtl network parsec QuickCheck unix \
	Cabal OpenGL GLUT OpenAL ALUT fgl X11 HGL HaXml HUnit Win32 time stm \
	xhtml
DARCS_CPPHS = http://www.cs.york.ac.uk/fp/darcs/cpphs

# End of general settings (leave this line unchanged)

PACKAGES	= packages/base/base.cabal
DARCS_GET	= darcs get --partial

# General targets:
#
# all:		(default) build a system that can be run in-place.
# install:	all + install in $(prefix) as supplied to configure.
# clean:	delete files generated in building, except those needed
#		for in-place use.
# distclean:	delete files created by configuring or building.
# veryclean:	delete most things that can be regenerated (though this
#		will require additional tools).
# check:	run regression tests

# Note: we have to build in src before building in libraries, as the
# latter uses the binaries in src.  See libraries/Makefile.in for
# details of the bootstrapping of the libraries.

all: $(PACKAGES) src/Makefile
	cd src; $(MAKE) all
	cd libraries; $(MAKE) all
	cd docs; $(MAKE) all

# We install the standard libraries and the simple demos.
# We don't install things which don't work on Unix (e.g. Win32).

install: install_all_but_docs
	cd docs; $(MAKE) install

# Install everything except documentation, which is installed differently
# by some packagers (e.g. rpm)

install_all_but_docs: $(PACKAGES) src/Makefile
	cd src; $(MAKE) install
	cd libraries; $(MAKE) install
	cd demos; $(MAKE) install

clean: clean_root
	cd src; if test -f Makefile; then $(MAKE) clean; fi
	cd libraries; if test -f Makefile; then $(MAKE) clean; fi
	cd docs; if test -f Makefile; then $(MAKE) clean; fi
	cd demos; if test -f Makefile; then $(MAKE) clean; fi

distclean: distclean_root
	cd src; if test -f Makefile; then $(MAKE) distclean; fi
	cd libraries; if test -f Makefile; then $(MAKE) distclean; fi
	cd docs; if test -f Makefile; then $(MAKE) distclean; fi
	cd demos; if test -f Makefile; then $(MAKE) distclean; fi

veryclean: veryclean_root
	cd src; if test -f Makefile; then $(MAKE) veryclean; fi
	cd libraries; if test -f Makefile; then $(MAKE) veryclean; fi
	cd docs; if test -f Makefile; then $(MAKE) veryclean; fi
	cd demos; if test -f Makefile; then $(MAKE) veryclean; fi

clean_root:
	$(RM) *.tar.gz *.rpm Defs.mk
	$(RM) *~

distclean_root: clean_root
	$(RM) -r config.status config.log config.cache autom4te.cache
	$(RM) MkDefs tests/config

veryclean_root: distclean_root
	cd debian; $(RM) control hugs.copyright libhugs-*-bundled.*

################################################################
# Regression tests (Unix only)
#
# Uses runstdtest (from ghc-0.26/ghc/glafp-utils/scripts), perl 5
# and /bin/sh (Bourne shell).
#
# "make verbosecheck" generates a lot of output to explain what is going on
# and reassure you that progress is being made.  This is great if you've
# never run these tests before - but if you just want to reassure yourself
# that nothing has broken since the last release, you might prefer to
# run "make check" which removes all the explanations and success
# stories - leaving just the errors (if any).
#
################################################################

check: all
	cd tests && sh testScript | if egrep -v '^--( |-----)'; then false; else true; fi

verbosecheck: all
	cd tests && sh testScript

# Building distributions

tarplus: Defs.mk
	$(MAKE) -f RPM.mk tar

tar: Defs.mk
	$(MAKE) PKGNAME=$(NAME) LIBRARIESDIRS='base haskell98 Cabal' -f RPM.mk tar

rpm: Defs.mk
	$(MAKE) -f RPM.mk rpm

Defs.mk: Makefile
	( echo '# Automatically extracted from Makefile (so edit that instead)';\
	  sed -n '/^# Start of general settings/,/^# End of general settings/p' Makefile;\
	) >$@

# Build phases:

# configuration

src/Makefile: configure
	$(RM) -r config.cache autom4te.cache
	LIBS=$(GNULIBS) ./configure $(EXTRA_CONFIGURE_OPTS)

configure: configure.ac aclocal.m4 $(PACKAGES)
	for dir in packages/*; do if test -f $$dir/configure.ac; \
		then (cd $$dir; autoreconf); fi; done
	-autoreconf

# fetching library sources and utility programs

$(PACKAGES):
	cvs -d $(CVS_ROOT) checkout -r $(HSLIBSTAG) `for lib in $(HSLIBSDIRS); do echo fptools/hslibs/$$lib; done`
	$(RM) -r packages cpphs hsc2hs
	mkdir packages
	for lib in $(LIBRARIESDIRS); do $(DARCS_GET) --repo-name=packages/$$lib $(DARCS_ROOT)/packages/$$lib; done
# We don't use this, so don't leave it there for Cabal to run
	cd packages; $(RM) HaXml/configure
# Move these so that make_bootlib won't convert them
	cd packages; mv Cabal/*.lhs Cabal/examples
	$(DARCS_GET) $(DARCS_CPPHS)
	$(DARCS_GET) $(DARCS_ROOT)/hsc2hs

debian/control: debian/control.in debian/make-control.hs
	cp License debian/hugs.copyright
# We need runhugs to build a Debian source package from CVS,
# but don't complain if it's unavailable.
	-runhugs -98 debian/make-control.hs `ls packages/*/*.cabal | grep -v Win32` 2>/dev/null

=== cpphs/Makefile ===
LIBRARY	= cpphs
VERSION	= 1.2

DIRS	= Language/Preprocessor/Cpphs \
	  Text/ParserCombinators

SRCS	= Language/Preprocessor/Cpphs.hs \
          Language/Preprocessor/Cpphs/CppIfdef.hs \
          Language/Preprocessor/Cpphs/HashDefine.hs \
          Language/Preprocessor/Cpphs/MacroPass.hs \
          Language/Preprocessor/Cpphs/Options.hs \
          Language/Preprocessor/Cpphs/Position.hs \
          Language/Preprocessor/Cpphs/ReadFirst.hs \
          Language/Preprocessor/Cpphs/RunCpphs.hs \
          Language/Preprocessor/Cpphs/SymTab.hs \
          Language/Preprocessor/Cpphs/Tokenise.hs \
          Language/Preprocessor/Unlit.hs \
          Text/ParserCombinators/HuttonMeijer.hs \
          cpphs.hs

AUX	= README LICENCE* CHANGELOG $(LIBRARY).cabal Setup.hs Makefile \
	  cpphs.hugs cpphs.compat \
	  tests/[A-BD-Z]* tests/[a-np-z]* \
	  docs/[a-z]*

all: $(LIBRARY)
package:
	tar cf tmp.tar $(SRCS) $(AUX)
	mkdir $(LIBRARY)-$(VERSION)
	cd $(LIBRARY)-$(VERSION); tar xf ../tmp.tar
	tar zcf $(LIBRARY)-$(VERSION).tar.gz $(LIBRARY)-$(VERSION)
	zip -r $(LIBRARY)-$(VERSION).zip $(LIBRARY)-$(VERSION)
	rm -r tmp.tar $(LIBRARY)-$(VERSION)
haddock: $(SRCS)
	mkdir -p docs/$(LIBRARY)
	for dir in $(DIRS); do mkdir -p docs/$(LIBRARY)/$$dir; done
	for file in $(SRCS); \
	    do HsColour -anchorHTML $$file \
	          >docs/$(LIBRARY)/`dirname $$file`/`basename $$file .hs`.html;\
	    done
	haddock --html --title=$(LIBRARY) \
	    --odir=docs/$(LIBRARY) --package=$(LIBRARY) \
	    --source-module="%{MODULE/.//}.html" \
	    --source-entity="%{MODULE/.//}.html#%{NAME}" \
	    $(SRCS)



$(LIBRARY): $(SRCS)
	$(HC) $(HFLAGS) $(HEAP) -o $@  $(SRCS)
	$(STRIP) $@

=== dotnet/tools/Makefile ===
#
# Makefile for hswrapgen, basic tool for generating
# Haskell .NET declarations from a .NET type.
#

CSC=csc
CSC_OPTS=
SRCS=App.cs AssemblyInfo.cs HsOutput.cs TypeInfo.cs

all : hswrapgen.exe

hswrapgen.exe : $(SRCS)
	$(CSC) $(CSC_OPTS) /out:hswrapgen.exe $(SRCS)

=== packages/ALUT/Makefile ===
# -----------------------------------------------------------------------------

TOP = ..
include $(TOP)/mk/boilerplate.mk
-include config.mk

ifneq "$(findstring clean, $(MAKECMDGOALS))" ""
# if we're cleaning, then config.mk might have been cleaned already
ALUT_BUILD_PACKAGE=yes
PACKAGE=ALUT
endif

ifneq "$(ALUT_BUILD_PACKAGE)" "no"

# -----------------------------------------------------------------------------

SUBDIRS = include

ifeq "$(IncludeExampleDirsInBuild)" "YES"
SUBDIRS += examples
endif

ALL_DIRS = Sound Sound/ALUT

PACKAGE_DEPS = base OpenGL OpenAL

SRC_HC_OPTS += -Wall -fffi -Iinclude '-\#include "HsALUT.h"' -cpp

# WinDoze DLL hell
ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
SRC_HC_OPTS += -DCALLCONV=stdcall
else
SRC_HC_OPTS += -DCALLCONV=ccall
endif

PACKAGE_CPP_OPTS += -DMAINTAINER=$(MAINTAINER)

SRC_HADDOCK_OPTS += -t "HOpenAL Libraries (ALUT package)"

# -----------------------------------------------------------------------------

package.conf.inplace \
package.conf.installed \
Sound/ALUT/Constants.$(way_)o : include/HsALUTConfig.h

endif

EXCLUDED_SRCS += Setup.hs

# -----------------------------------------------------------------------------

DIST_CLEAN_FILES += ALUT.buildinfo config.cache config.status config.mk

extraclean::
	$(RM) -rf autom4te.cache

# -----------------------------------------------------------------------------

include $(TOP)/mk/target.mk

=== packages/Cabal/Makefile ===
TOP=..

ifeq "$(findstring boilerplate.mk, $(wildcard $(TOP)/mk/*))" ""
# ----------------------------------------------------------------------------
# Standalone Makefile:

CABALVERSION=1.1.5.9.2
KIND=rc
#KIND=latest
GHCFLAGS= --make -fno-warn-unused-matches -cpp
# later: -Wall
PREF=/usr/local
USER_FLAG =
GHCPKGFLAGS =
HC=ghc
HC_PKG=ghc-pkg
# Comment out this line if your system doesn't have System.Posix.
ISPOSIX=-DHAVE_UNIX_PACKAGE

ifdef user
USER_FLAG = --user
GHCPKGFLAGS = -f ~/.ghc-packages
GHCFLAGS += -package-conf ~/.ghc-packages
endif

# the cabal tarball...
CABALBALL=cabal-$(CABALVERSION).tar.gz

all: moduleTest

# build the library itself

setup::
	mkdir -p dist/tmp
	$(HC) $(GHCFLAGS) -i. -odir dist/tmp -hidir dist/tmp Setup.lhs -o setup

Setup-nhc:
	hmake -nhc98 -package base -prelude Setup

config: setup
	./setup configure --ghc --prefix=$(PREF)

build: build-stamp
build-stamp: config
	./setup build
#	cd cabal-install     && mkdir -p dist/tmp && $(HC) $(GHCFLAGS) -i.. -odir dist/tmp -hidir dist/tmp Setup.lhs -o setup && ./setup configure --ghc --prefix=$(PREF) && ./setup build 
#	cd cabal-setup     && mkdir -p dist/tmp && $(HC) $(GHCFLAGS) -i.. -odir dist/tmp -hidir dist/tmp Setup.hs -o setup && ./setup configure --ghc --prefix=$(PREF) && ./setup build 
install: build-stamp
	./setup install $(USER_FLAG)
#	cd cabal-install     && ./setup install
#	cd cabal-setup       && ./setup install

hugsbootstrap:
	rm -rf dist/tmp dist/hugs
	mkdir -p dist/tmp
	mkdir dist/hugs
	cp -r Distribution dist/tmp
	hugs-package dist/tmp dist/hugs
	cp Setup.lhs Cabal.cabal dist/hugs

hugsinstall: hugsbootstrap
	cd dist/hugs && ./Setup.lhs configure --hugs
	cd dist/hugs && ./Setup.lhs build
	cd dist/hugs && ./Setup.lhs install

haddock: setup
	./setup configure
	./setup haddock

clean-doc:
	cd doc && $(MAKE) clean

doc: haddock
	docbook2html doc/Cabal.xml --output doc/users-guide

clean: clean-cabal clean-hunit clean-test clean-doc

clean-cabal:
	-rm -f Distribution/*.o Distribution/*.hi
	-rm -f Distribution/Simple/*.o Distribution/Simple/*.hi
	-rm -f Compat/*.o Compat/*.hi
	-rm -f darcs* out.build *~ semantic.cache* x*.html
	-rm -f library-infrastructure--darcs.tar.gz
	-rm -rf setup *.o *.hi moduleTest dist installed-pkg-config
	-rm -f build-stamp
	-rm -rf dist/hugs

clean-hunit:
	-rm -f hunit-stamp hunitInstall-stamp
	cd tests/HUnit-1.0 && $(MAKE) clean

clean-test:
	cd tests/A && $(MAKE) clean
	cd tests/wash2hs && $(MAKE) clean

remove: remove-cabal remove-hunit
remove-cabal:
	-$(HC_PKG) $(GHCPKGFLAGS) -r Cabal
	-rm -rf $(PREF)/lib/Cabal-0.1
remove-hunit:
	-$(HC_PKG) $(GHCPKGFLAGS) -r HUnit
	-rm -rf $(PREF)/lib/HUnit-1.0

# dependencies (included):

hunit: hunit-stamp
hunit-stamp:
	cd tests/HUnit-1.0 && $(MAKE) && ./setup configure --prefix=$(PREF) && ./setup build
	touch $@

hunitInstall: hunitInstall-stamp
hunitInstall-stamp: hunit-stamp
	cd tests/HUnit-1.0 && ./setup install $(USER_FLAG)
	touch $@

# testing...

moduleTest:
	mkdir -p dist/debug
	$(HC) $(GHCFLAGS) $(ISPOSIX) -DDEBUG -odir dist/debug -hidir dist/debug -idist/debug/:src:tests/HUnit-1.0/src tests/ModuleTest.hs -o moduleTest 

tests: moduleTest clean
	cd tests/A && $(MAKE) clean
	cd tests/HUnit-1.0 && $(MAKE) clean
	cd tests/A && $(MAKE)
	cd tests/HUnit-1.0 && $(MAKE)

check:
	rm -f moduleTest
	$(MAKE) moduleTest
	./moduleTest

# distribution...

pushall:
	darcs push ijones@darcs.haskell.org:/home/darcs/cabal
	darcs push ijones@darcs.haskell.org:/home/darcs/packages/Cabal

pullall:
	darcs pull ijones@darcs.haskell.org:/home/darcs/cabal
	darcs pull ijones@darcs.haskell.org:/home/darcs/packages/Cabal


pushdist: pushall dist
	scp $(TMPDISTLOC)/cabal.tar.gz ijones@www.haskell.org:~/cabal/cabal-code.tgz
#	PUSH ELSEWHERE: scp changelog ijones@www.haskell.org:~/cabal/release/changelog
#	PUSH ELSEWHERE: scp releaseNotes ijones@www.haskell.org:~/cabal/release/notes
#	rm -f /tmp/cabal-code.tgz

deb: dist
	cd $(TMPDISTLOC) && ln -s $(CABALBALL) haskell-cabal_$(CABALVERSION).orig.tar.gz
	cd $(TMPDISTLOC) && tar -zxvf $(CABALBALL)
	mv $(TMPDISTLOC)/cabal $(TMPDISTLOC)/haskell-cabal-$(CABALVERSION)
	cd $(TMPDISTLOC)/haskell-cabal-$(CABALVERSION) && debuild

$(CABALBALL):
	darcs record
	rm -rf /tmp/cabal* /tmp/Cabal*
	rm -rf $(TMPDISTLOC)
	darcs dist --dist-name=cabal-$(CABALVERSION)

TMPDISTLOC=/tmp/cabaldist

# after this command, there will be cabal.tar.gz in $(TMPDISTLOC),
# which will have built docs, haddock, and source code.

dist: haddock $(CABALBALL)
	rm -rf $(TMPDISTLOC)
	mkdir $(TMPDISTLOC)
	mv $(CABALBALL) $(TMPDISTLOC)
	cd $(TMPDISTLOC) && tar -zxvf $(CABALBALL)
	#mkdir $(TMPDISTLOC)/cabal/doc
	$(MAKE) doc
	cp -r dist/doc/html $(TMPDISTLOC)/cabal-$(CABALVERSION)/doc/API
	cp -r doc/users-guide $(TMPDISTLOC)/cabal-$(CABALVERSION)/doc/users-guide
	cd ~/prgs/build/haskell-report/packages && docbook2html -o /tmp/pkg-spec-html pkg-spec.sgml && docbook2pdf pkg-spec.sgml -o /tmp
	cp -r /tmp/pkg-spec{-html,.pdf} $(TMPDISTLOC)/cabal-$(CABALVERSION)/doc

	cd $(TMPDISTLOC) && rm -f $(CABALBALL) && tar -zcvf $(CABALBALL) cabal-$(CABALVERSION)
	@echo "Cabal tarball built: $(TMPDISTLOC)/$(CABALBALL)"

release: dist
	mkdir $(TMPDISTLOC)/release
	cp $(TMPDISTLOC)/cabal-$(CABALVERSION)/releaseNotes $(TMPDISTLOC)/release
	cp $(TMPDISTLOC)/cabal-$(CABALVERSION)/changelog $(TMPDISTLOC)/release
	cp -r $(TMPDISTLOC)/cabal-$(CABALVERSION)/doc $(TMPDISTLOC)/release
	cp $(TMPDISTLOC)/cabal-$(CABALVERSION).tar.gz  $(TMPDISTLOC)/release/cabal-$(CABALVERSION).tar.gz
	scp -r $(TMPDISTLOC)/release www.haskell.org:/home/haskell/cabal/release/cabal-$(CABALVERSION)
	ssh www.haskell.org 'cd /home/haskell/cabal/release && rm -f $(KIND) && ln -s cabal-$(CABALVERSION) $(KIND)'

else # boilerplate.mk exists
# ----------------------------------------------------------------------------
# GHC build tree Makefile:

include $(TOP)/mk/boilerplate.mk

SUBDIRS = doc #cabal-setup

ALL_DIRS = \
	Distribution \
	Distribution/Simple \
	Distribution/PreProcess \
	Distribution/Compat \
	Language/Haskell

EXCLUDED_SRCS = DefaultSetup.lhs

PACKAGE		= Cabal
VERSION		= 1.1.4

PACKAGE_DEPS	= base

SRC_HADDOCK_OPTS += -t "Haskell Hierarchical Libraries (Cabal package)"

SRC_HC_OPTS   += -cpp

include $(TOP)/mk/target.mk

endif

=== packages/GLUT/Makefile ===
# -----------------------------------------------------------------------------

TOP = ..
include $(TOP)/mk/boilerplate.mk
-include config.mk

ifneq "$(findstring clean, $(MAKECMDGOALS))" ""
# if we're cleaning, then config.mk might have been cleaned already
GLUT_BUILD_PACKAGE=yes
PACKAGE=GLUT
endif

ifneq "$(GLUT_BUILD_PACKAGE)" "no"

# -----------------------------------------------------------------------------

SUBDIRS = cbits include

ifeq "$(IncludeExampleDirsInBuild)" "YES"
SUBDIRS += examples
endif

ALL_DIRS = \
	Graphics/UI \
	Graphics/UI/GLUT \
	Graphics/UI/GLUT/Callbacks

PACKAGE_DEPS = base OpenGL

SRC_HC_OPTS += -Wall -fffi -Iinclude '-\#include "HsGLUT.h"' -cpp

# WinDoze DLL hell
ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
SRC_HC_OPTS += -DCALLCONV=stdcall
else
SRC_HC_OPTS += -DCALLCONV=ccall
endif

PACKAGE_CPP_OPTS += -DMAINTAINER=$(MAINTAINER)

SRC_HADDOCK_OPTS += -t "HOpenGL Libraries (GLUT package)"

# -----------------------------------------------------------------------------

package.conf.inplace \
package.conf.installed : include/HsGLUTConfig.h

Graphics/UI/GLUT/Begin.$(way_)o \
Graphics/UI/GLUT/Callbacks/Window.$(way_)o \
Graphics/UI/GLUT/Fonts.$(way_)o \
Graphics/UI/GLUT/Objects.$(way_)o \
Graphics/UI/GLUT/QueryUtils.$(way_)o : include/HsGLUTExt.h

# -----------------------------------------------------------------------------

STUBOBJS += \
   Graphics/UI/GLUT/Menu_stub.$(way_)o \
   Graphics/UI/GLUT/Callbacks/Global_stub.$(way_)o \
   Graphics/UI/GLUT/Callbacks/Registration_stub.$(way_)o \
   Graphics/UI/GLUT/Callbacks/Window_stub.$(way_)o

CLEAN_FILES += $(STUBOBJS) \
   Graphics/UI/GLUT/Menu_stub.[ch] \
   Graphics/UI/GLUT/Callbacks/Global_stub.[ch] \
   Graphics/UI/GLUT/Callbacks/Registration_stub.[ch] \
   Graphics/UI/GLUT/Callbacks/Window_stub.[ch]

endif

EXCLUDED_SRCS += Setup.hs

# -----------------------------------------------------------------------------

DIST_CLEAN_FILES += GLUT.buildinfo config.cache config.status config.mk

extraclean::
	$(RM) -rf autom4te.cache

# -----------------------------------------------------------------------------

include $(TOP)/mk/target.mk

=== packages/HGL/Makefile ===
# -----------------------------------------------------------------------------

TOP = ..
include $(TOP)/mk/boilerplate.mk
-include config.mk

ifneq "$(findstring clean, $(MAKECMDGOALS))" ""
# if we're cleaning, then config.mk might have been cleaned already
HGL_BUILD_PACKAGE=yes
PACKAGE=HGL
endif

# -----------------------------------------------------------------------------

ifeq "$(HGL_BUILD_PACKAGE)" "yes"

# We do not make examples a subdir because then we can't avoid building it
# SUBDIRS = examples
SUBDIRS = 

ALL_DIRS = \
	Graphics \
	Graphics/HGL \
	Graphics/HGL/Draw \
	Graphics/HGL/Internals

ifneq "$(PLATFORM)" ""
ALL_DIRS      += Graphics/HGL/$(PLATFORM)
endif

PACKAGE_DEPS   = base $(PLATFORM)

SRC_HC_OPTS   += -cpp -Iinclude

PACKAGE_CPP_OPTS += -DMAINTAINER=$(MAINTAINER)

SRC_HADDOCK_OPTS += -t "Graphics Libraries ($(PACKAGE) package)"

# -----------------------------------------------------------------------------

HGL/Graphics/HGL/Draw/Brush.$(way_)o \
HGL/Graphics/HGL/Draw/Font.$(way_)o \
HGL/Graphics/HGL/Draw/Pen.$(way_)o \
HGL/Graphics/HGL/Draw/Picture.$(way_)o \
HGL/Graphics/HGL/Draw/Region.$(way_)o \
HGL/Graphics/HGL/Draw/Text.$(way_)o \
HGL/Graphics/HGL/Internals/Draw.$(way_)o \
HGL/Graphics/HGL/Internals/Types.$(way_)o \
HGL/Graphics/HGL/Key.$(way_)o \
HGL/Graphics/HGL/Run.$(way_)o \
HGL/Graphics/HGL/Window.$(way_)o \ : include/HsHGLConfig.h

endif

EXCLUDED_SRCS += Setup.hs

# -----------------------------------------------------------------------------

DIST_CLEAN_FILES += include/HsHGLConfig.h HGL.buildinfo config.cache config.status
DIST_CLEAN_FILES += config.mk

extraclean::
	$(RM) -rf autom4te.cache

# -----------------------------------------------------------------------------

include $(TOP)/mk/target.mk

=== packages/HUnit/Makefile ===
# -----------------------------------------------------------------------------

TOP=..
include $(TOP)/mk/boilerplate.mk

# -----------------------------------------------------------------------------

ifeq "$(IncludeExampleDirsInBuild)" "YES"
SUBDIRS += examples
endif

ALL_DIRS = \
	Test \
	Test/HUnit

PACKAGE = HUnit
VERSION = 1.1
PACKAGE_DEPS = base

SRC_HC_OPTS += -cpp

SRC_HADDOCK_OPTS += -t "Haskell Hierarchical Libraries ($(PACKAGE) package)"

# -----------------------------------------------------------------------------

include $(TOP)/mk/target.mk

=== packages/HaXml/Makefile ===
SOFTWARE = HaXml
VERSION  = 1.17

CPP      = cpp -traditional
#CPP     = cpphs --text 	# useful e.g. on MacOS X

DIRS = Text Text/XML Text/XML/HaXml Text/XML/HaXml/Html \
	Text/XML/HaXml/Xtract Text/XML/HaXml/DtdToHaskell \
	Text/ParserCombinators

SRCS = \
	src/Text/XML/HaXml.hs src/Text/XML/HaXml/Combinators.hs \
	src/Text/XML/HaXml/Posn.hs src/Text/XML/HaXml/Lex.hs \
	src/Text/XML/HaXml/Parse.hs src/Text/XML/HaXml/Pretty.hs \
	src/Text/XML/HaXml/Types.hs src/Text/XML/HaXml/Validate.hs \
	src/Text/XML/HaXml/Wrappers.hs \
	src/Text/XML/HaXml/Verbatim.hs src/Text/XML/HaXml/Escape.hs \
	src/Text/XML/HaXml/OneOfN.hs \
	src/Text/XML/HaXml/ParseLazy.hs \
	src/Text/XML/HaXml/TypeMapping.hs src/Text/XML/HaXml/XmlContent.hs \
	src/Text/XML/HaXml/SAX.hs \
	src/Text/XML/HaXml/ShowXmlLazy.hs \
	src/Text/XML/HaXml/Html/Generate.hs src/Text/XML/HaXml/Html/Parse.hs \
	src/Text/XML/HaXml/Html/Pretty.hs \
	src/Text/XML/HaXml/Html/ParseLazy.hs \
	src/Text/XML/HaXml/Xtract/Combinators.hs \
	src/Text/XML/HaXml/Xtract/Lex.hs \
	src/Text/XML/HaXml/Xtract/Parse.hs \
	src/Text/XML/HaXml/DtdToHaskell/TypeDef.hs \
	src/Text/XML/HaXml/DtdToHaskell/Convert.hs \
	src/Text/XML/HaXml/DtdToHaskell/Instance.hs \
	src/Text/ParserCombinators/HuttonMeijer.hs \
	src/Text/ParserCombinators/HuttonMeijerWallace.hs \
	src/Text/ParserCombinators/Poly.hs \
	src/Text/ParserCombinators/PolyState.hs \
	src/Text/ParserCombinators/PolyLazy.hs \
	src/Text/ParserCombinators/PolyStateLazy.hs \
	src/Text/ParserCombinators/TextParser.hs

TOOLSRCS = \
	src/tools/DtdToHaskell.hs src/tools/Xtract.hs src/tools/Validate.hs \
	src/tools/Canonicalise.hs src/tools/MkOneOf.hs \
	src/tools/CanonicaliseLazy.hs src/tools/XtractLazy.hs \

AUX =	configure Makefile src/Makefile src/pkg.conf docs/* examples/* \
	README LICENCE* COPYRIGHT script/echo.c rpm.spec Build.bat \
	HaXml.cabal Setup.hs
ALLFILES = $(SRCS) $(TOOLSRCS) $(AUX)
# These files in CVS are NOT included in the src distribution.
NOT =	Makefile.inc Makefile.nhc98 src/Makefile.inc src/Makefile.nhc98

.PHONY: all libs tools haddock install register

COMPILERS = $(shell cat obj/compilers)
LIBS  = $(patsubst %, libs-%, $(COMPILERS))
TOOLS = $(patsubst %, tools-%, $(COMPILERS))
INSTALL = $(patsubst %, install-%, $(COMPILERS))
FILESONLY = $(patsubst %, install-filesonly-%, $(COMPILERS))

all: $(LIBS) $(TOOLS)
libs: $(LIBS)
tools: $(TOOLS)
install: $(INSTALL)
install-filesonly: $(FILESONLY)
libs-ghc:
	cd obj/ghc; $(MAKE) HC=$(shell cat obj/ghccmd) libs
libs-nhc98:
	cd obj/nhc98; $(MAKE) HC=nhc98 libs
libs-hugs:
	@echo "No building required for Hugs version of HaXml libs."
tools-ghc:
	cd obj/ghc; $(MAKE) HC=$(shell cat obj/ghccmd) toolset
tools-nhc98:
	cd obj/nhc98; $(MAKE) HC=nhc98 toolset
tools-hugs:
	@echo "No building required for Hugs version of HaXml tools."
install-ghc:
	cd obj/ghc; $(MAKE) HC=$(shell cat obj/ghccmd) install-ghc
install-nhc98:
	cd obj/nhc98; $(MAKE) HC=nhc98 install-nhc98
install-hugs:
	hugs-package src
	cd obj/hugs; $(MAKE) install-tools-hugs
install-filesonly-ghc:
	cd obj/ghc; $(MAKE) HC=$(shell cat obj/ghccmd) install-filesonly-ghc
install-filesonly-nhc98:
	cd obj/nhc98; $(MAKE) HC=nhc98 install-filesonly-nhc98
install-filesonly-hugs: install-hugs
haddock:
	mkdir -p docs/HaXml
	for dir in $(DIRS); \
		do mkdir -p docs/HaXml/src/$$dir; \
		done
	for file in $(SRCS); \
		do $(CPP) -D__NHC__ $$file >$$file.uncpp; \
		   HsColour -anchorHTML $$file >docs/HaXml/`dirname $$file`/`basename $$file .hs`.html; \
		done
	haddock --html --title=HaXml --odir=docs/HaXml --package=HaXml \
		--source-module="src/%{MODULE/.//}.html" \
		--source-entity="src/%{MODULE/.//}.html#%{NAME}" \
		$(patsubst %, %.uncpp, $(SRCS))
	rm -f $(patsubst %, %.uncpp, $(SRCS))

# packaging a distribution

srcDist: $(ALLFILES) haddock
	rm -f $(SOFTWARE)-$(VERSION).tar $(SOFTWARE)-$(VERSION).tar.gz
	mkdir $(SOFTWARE)-$(VERSION)
	tar cf - $(ALLFILES) | ( cd $(SOFTWARE)-$(VERSION); tar xf - )
	rm -rf $(SOFTWARE)-$(VERSION)/docs/CVS
	rm -rf $(SOFTWARE)-$(VERSION)/examples/CVS
	rm -rf $(SOFTWARE)-$(VERSION)/examples/SMIL/CVS
	rm -rf $(SOFTWARE)-$(VERSION)/examples/OpenOffice.org/CVS
	tar cf $(SOFTWARE)-$(VERSION).tar $(SOFTWARE)-$(VERSION)
	rm -rf $(SOFTWARE)-$(VERSION)
	gzip $(SOFTWARE)-$(VERSION).tar

zipDist: $(ALLFILES) haddock
	rm -f $(SOFTWARE)-$(VERSION).zip
	mkdir $(SOFTWARE)-$(VERSION)
	tar cf - $(ALLFILES) | ( cd $(SOFTWARE)-$(VERSION); tar xf - )
	-rm -rf $(SOFTWARE)-$(VERSION)/docs/CVS
	-rm -rf $(SOFTWARE)-$(VERSION)/examples/CVS
	-rm -rf $(SOFTWARE)-$(VERSION)/examples/SMIL/CVS
	-rm -rf $(SOFTWARE)-$(VERSION)/examples/OpenOffice.org/CVS
	zip -r $(SOFTWARE)-$(VERSION).zip $(SOFTWARE)-$(VERSION)
	rm -rf $(SOFTWARE)-$(VERSION)


# clear up rubbish
clean:
	rm -rf obj/ghc obj/nhc98 obj/hugs
	cd examples;    rm -f *.hi *.o
realclean: clean
	rm -f DtdToHaskell Xtract Validate Canonicalise MkOneOf
	rm -f XtractLazy CanonicaliseLazy

=== packages/OpenAL/Makefile ===
# -----------------------------------------------------------------------------

TOP = ..
include $(TOP)/mk/boilerplate.mk
-include config.mk

ifneq "$(findstring clean, $(MAKECMDGOALS))" ""
# if we're cleaning, then config.mk might have been cleaned already
AL_BUILD_PACKAGE=yes
PACKAGE=OpenAL
endif

ifneq "$(AL_BUILD_PACKAGE)" "no"

# -----------------------------------------------------------------------------

SUBDIRS = include

ifeq "$(IncludeExampleDirsInBuild)" "YES"
SUBDIRS += examples
endif

ALL_DIRS = \
	Sound \
	Sound/OpenAL \
	Sound/OpenAL/AL \
	Sound/OpenAL/ALC

PACKAGE_DEPS = base OpenGL

SRC_HC_OPTS += -Wall -fffi -Iinclude '-\#include "HsOpenAL.h"' -cpp

# WinDoze DLL hell
# NOTE: For some obscure/unknown reason, OpenAL uses ccall, even on WinDoze...
SRC_HC_OPTS += -DCALLCONV=ccall
ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
SRC_HC_OPTS := $(subst -mno-cygwin,,$(SRC_HC_OPTS))
endif

PACKAGE_CPP_OPTS += -DMAINTAINER=$(MAINTAINER)

SRC_HADDOCK_OPTS += -t "HOpenAL Libraries (OpenAL package)" -p prologue.txt

# -----------------------------------------------------------------------------

package.conf.inplace \
package.conf.installed \
Sound/OpenAL/Config.$(way_)o \
Sound/OpenAL/Constants.$(way_)o : include/HsOpenALConfig.h

endif

EXCLUDED_SRCS += Setup.hs

# -----------------------------------------------------------------------------

DIST_CLEAN_FILES += OpenAL.buildinfo config.cache config.status config.mk

extraclean::
	$(RM) -rf autom4te.cache

# -----------------------------------------------------------------------------

include $(TOP)/mk/target.mk

=== packages/OpenGL/Makefile ===
# -----------------------------------------------------------------------------

TOP = ..
include $(TOP)/mk/boilerplate.mk
-include config.mk

ifneq "$(findstring clean, $(MAKECMDGOALS))" ""
# if we're cleaning, then config.mk might have been cleaned already
GL_BUILD_PACKAGE=yes
PACKAGE=OpenGL
endif

ifneq "$(GL_BUILD_PACKAGE)" "no"

# -----------------------------------------------------------------------------

SUBDIRS = cbits include

ALL_DIRS = \
	Graphics/Rendering \
	Graphics/Rendering/OpenGL \
	Graphics/Rendering/OpenGL/GL \
	Graphics/Rendering/OpenGL/GL/PixelRectangles \
	Graphics/Rendering/OpenGL/GL/Texturing \
	Graphics/Rendering/OpenGL/GLU

PACKAGE_DEPS = base

SRC_HC_OPTS += -Wall -fffi -Iinclude '-\#include "HsOpenGL.h"' -cpp \
	       -funbox-strict-fields $(GLU_CFLAGS)
SRC_CC_OPTS += $(GLU_CFLAGS)

# WinDoze DLL hell
ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
SRC_HC_OPTS += -DCALLCONV=stdcall
SRC_HC_OPTS := $(subst -mno-cygwin,,$(SRC_HC_OPTS))
else
SRC_HC_OPTS += -DCALLCONV=ccall
endif

# Needed for at least Graphics/Rendering/OpenGL/GL/QueryUtils.p_o
ifeq "$(hppa_TARGET_ARCH)" "1"
SRC_HC_OPTS += -optc-mbig-switch
endif

PACKAGE_CPP_OPTS += -DMAINTAINER=$(MAINTAINER)

SRC_HADDOCK_OPTS += -t "HOpenGL Libraries ($(PACKAGE) package)"

# -----------------------------------------------------------------------------

package.conf.inplace \
package.conf.installed \
OpenGL/Graphics/Rendering/OpenGL/GL/BasicTypes.$(way_)o : include/HsOpenGLConfig.h

Graphics/Rendering/OpenGL/GL/CoordTrans.$(way_)o \
Graphics/Rendering/OpenGL/GL/Evaluators.$(way_)o \
Graphics/Rendering/OpenGL/GL/PixelRectangles/PixelMap.$(way_)o \
Graphics/Rendering/OpenGL/GL/RasterPos.$(way_)o \
Graphics/Rendering/OpenGL/GL/Rectangles.$(way_)o \
Graphics/Rendering/OpenGL/GL/VertexSpec.$(way_)o : include/HsOpenGLConfig.h include/HsOpenGLTypes.h

Graphics/Rendering/OpenGL/GL/BeginEnd.$(way_)o \
Graphics/Rendering/OpenGL/GL/BufferObjects.$(way_)o \
Graphics/Rendering/OpenGL/GL/CoordTrans.$(way_)o \
Graphics/Rendering/OpenGL/GL/PerFragment.$(way_)o \
Graphics/Rendering/OpenGL/GL/PixelRectangles/ColorTable.$(way_)o \
Graphics/Rendering/OpenGL/GL/PixelRectangles/Convolution.$(way_)o \
Graphics/Rendering/OpenGL/GL/PixelRectangles/Histogram.$(way_)o \
Graphics/Rendering/OpenGL/GL/PixelRectangles/Minmax.$(way_)o \
Graphics/Rendering/OpenGL/GL/PointParameter.$(way_)o \
Graphics/Rendering/OpenGL/GL/RasterPos.$(way_)o \
Graphics/Rendering/OpenGL/GL/Rectangles.$(way_)o \
Graphics/Rendering/OpenGL/GL/Texturing/Specification.$(way_)o \
Graphics/Rendering/OpenGL/GL/VertexArrays.$(way_)o \
Graphics/Rendering/OpenGL/GL/VertexSpec.$(way_)o \
Graphics/Rendering/OpenGL/GLU/Matrix.$(way_)o \ : include/HsOpenGLExt.h

# -----------------------------------------------------------------------------

STUBOBJS += \
   Graphics/Rendering/OpenGL/GLU/NURBS_stub.$(way_)o \
   Graphics/Rendering/OpenGL/GLU/Quadrics_stub.$(way_)o \
   Graphics/Rendering/OpenGL/GLU/Tessellation_stub.$(way_)o

CLEAN_FILES += $(STUBOBJS) \
   Graphics/Rendering/OpenGL/GLU/NURBS_stub.[ch] \
   Graphics/Rendering/OpenGL/GLU/Quadrics_stub.[ch] \
   Graphics/Rendering/OpenGL/GLU/Tessellation_stub.[ch]

endif

EXCLUDED_SRCS += Setup.hs

# -----------------------------------------------------------------------------

DIST_CLEAN_FILES += OpenGL.buildinfo config.cache config.status config.mk

extraclean::
	$(RM) -rf autom4te.cache

# -----------------------------------------------------------------------------

include $(TOP)/mk/target.mk

=== packages/QuickCheck/Makefile ===
TOP=..
include $(TOP)/mk/boilerplate.mk

SUBDIRS = 

ALL_DIRS = \
	Test Test/QuickCheck \
	Debug Debug/QuickCheck

PACKAGE = QuickCheck
VERSION = 1.0
PACKAGE_DEPS = base

SRC_HADDOCK_OPTS += -t "Haskell Hierarchical Libraries ($(PACKAGE) package)"

include $(TOP)/mk/target.mk

=== debian/changelog ===
hugs98 (98.200609.21-7) unstable; urgency=medium

  * QA upload.

  * Added d/gbp.conf to describe branch layout.
  * Updated vcs in d/control to Salsa.
  * Updated d/gbp.conf to enforce the use of pristine-tar.
  * Updated Standards-Version from 4.6.0 to 4.7.0.
  * Use wrap-and-sort -at for debian control files
  * Replaced obsolete libncurses5-dev build dependency with libncurses-dev.
  * Update lintian override info format in
    d/libhugs-cabal-bundled.lintian-overrides on line 1.
  * Remove obsolete linda overrides: libhugs-cabal-bundled.linda-overrides
  * Replaced obsolete build dependency libgl1-mesa-dev with libgl-dev.
  * Removed unneeded checks for root in d/rules.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 04 May 2024 07:54:05 +0200

hugs98 (98.200609.21-6) unstable; urgency=medium

  * QA upload.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Set Debian QA Group as maintainer.
  * Using new DH level format. Consequently:
      - debian/compat: Removed.
      - debian/control: Changed from 'debhelper' to 'debhelper-compat' in
                        Build-Depends field and bumped level to 13.
  * debian/changelog: Removed blank spaces.
  * debian/control:
      - Added ${misc:Depends} in Depends.
      - Added Homepage.
      - Added 'Rules-Requires-Root: no' to source stanza.
      - Bumped Standards-Version to 4.6.0.
      - Change 'Section' in sub packages to haskell.
      - changing the long description in libhugs-fgl-bundled,
        libhugs-network-bundled and libhugs-time-bundled.
      - Organized Depends.
      - Removed article at the beginning of the short description.
      - Removed autotools-dev is no longer needed.
      - Removed empty paragraph the lines after the first line of the
        "Description:" field.
      - Removed "Priority: optional" in sub packages.
  * debian/hugs.menu: Renomed section "App" for "Applications".
  * debian/menu: Renomed section "App" for "Applications".
  * debian/patches/old-patches.patch: Created.
  * debian/rules:
      - Added "dh sequencer" (Closes: #999196).
      - Added option '-g' in CFLAGS.
      - Removed blank spaces.
      - Replaced "dh_clean -k" with "dh_prep".
  * debian/source/format: Created.
  * debian/watch:
      - Bumped to version 4.
      - Updated the source address.

 -- Hugo Torres de Lima <hugotorres@protonmail.com>  Sat, 11 Dec 2021 20:09:03 -0300

hugs98 (98.200609.21-5.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "ftbfs with GCC-5":
    apply patch from Elizabeth J Dall:
    build with -std=gnu89 in debian/rules.
    (Closes: #777903)

 -- gregor herrmann <gregoa@debian.org>  Sat, 18 Jul 2015 20:07:51 +0200

hugs98 (98.200609.21-5.3) unstable; urgency=low

  * Non-maintainer upload.
  * Build-depend on libreadline-dev | libreadline5-dev. Closes: #553783.

 -- Matthias Klose <doko@debian.org>  Fri, 02 Sep 2011 12:09:52 +0200

hugs98 (98.200609.21-5.2) unstable; urgency=high

  * Non-maintainer upload.
  * Fix build error: run autoconf in packages/network as configure.ac
    has been changed. (Closes: #608220)
  * Set urgency to "high" for RC bugfix.

 -- Felix Geyer <debfx-pkg@fobos.de>  Sun, 16 Jan 2011 23:22:37 +0100

hugs98 (98.200609.21-5.1) unstable; urgency=high

  * Non-maintainer upload.
  * Improve SO_PEERCRED/struct ucred detection by applying a patch stolen
    from haskell-network's 64a3779811dd9965d864c8b9c85c49a261c4eb69. This
    fixes the build with glibc 2.8 and higher (Closes: #608220). As a
    reminder, the build ought to break with such compiler errors, instead
    of creating mostly-empty packages, as noted by Jakub Wilk.
  * Set urgency to “high” for RC bugfix.

 -- Cyril Brulebois <kibi@debian.org>  Wed, 05 Jan 2011 17:27:04 +0100

hugs98 (98.200609.21-5) unstable; urgency=low

  * configure.ac: temporarily add ${Hugs}/libraries to the search path of
    Hugs as most Debian packages install their Hugs libraries there.
  * Runned autoconf as we have changed configure.ac.
  * debian/compat: Bump debhelper compatibility level to 5.
  * debian/control{,in}:
    - Bump versioned dependency on debhelper.
    - Drop the non-existing haskell-cabal package from the Suggest field.

 -- Arjan Oosting <arjan@debian.org>  Tue, 17 Apr 2007 00:45:05 +0200

hugs98 (98.200609.21-4) experimental; urgency=low

  * debian/{make-control.hs,control,control.in}: make the dependency
    between libhugs-*-bundled and hugs versioned.

 -- Arjan Oosting <arjan@debian.org>  Thu, 21 Dec 2006 22:19:57 +0100

hugs98 (98.200609.21-3) experimental; urgency=low

  * Build the bundled GLUT package again:
    - debian/control{,.in}: Add freeglut3-dev, libxi-dev and libxmu-dev to
      the Build-Depends which are needed to build the GLUT package.
    - debian/control: Add libhugs-glut-bundled entry.
  * debian/rules: echo config.log to stdout when package is not build so
    we can see where the build daemons fail.

 -- Arjan Oosting <arjan@debian.org>  Wed, 13 Dec 2006 14:33:21 +0100

hugs98 (98.200609.21-2) experimental; urgency=low

  * src/builtin.c: replace g constraint with r constraint in the inline
    assembly code as suggested and applied upstream by Ross Paterson. This
    should fix the FTBFS on powerpc. (Closes: #402476)

 -- Arjan Oosting <arjan@debian.org>  Mon, 11 Dec 2006 22:32:54 +0100

hugs98 (98.200609.21-1) experimental; urgency=low

  * Add myself to the Uploaders field.
  * The hugs binary package has been split into several binary packages:
    - the hugs binary package contains the interpreter and the base and
      haskell98 librariespackages
    - the other libhugs-*-bundled binary packages each contain one the
      other haskell libraries shipped with hugs. (Closes: 377501)
  * New upstream release. Upstream changes since the previous Debian
    package:
    - The default current module is now the empty module Hugs.
    - The compatibility libraries are no longer included on the default


=== debian/control ===
Source: hugs98
Section: interpreters
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: bison,
               debhelper-compat (= 13),
               docbook,
               docbook-dsssl,
               docbook-utils,
               dpkg-dev (>= 1.13.19),
               freeglut3-dev,
               libalut-dev,
               libgl-dev,
               libglu1-mesa-dev,
               libncurses-dev,
               libopenal-dev,
               libreadline-dev | libreadline5-dev,
               libxi-dev,
               libxmu-dev,
               libxt-dev,
Standards-Version: 4.7.0
Homepage: https://www.haskell.org/hugs/
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/hugs98
Vcs-Git: https://salsa.debian.org/debian/hugs98.git

Package: hugs
Architecture: any
Depends: libhugs-base,
         libhugs-haskell98,
         ${misc:Depends},
         ${shlibs:Depends},
Conflicts: hugs98,
Provides: hugs98,
Replaces: hugs98,
Suggests: cpphs,
          haskell-doc,
          haskell-mode,
Description: Haskell 98 interpreter
 Hugs is an interpreter for the non-strict, purely functional programming
 language Haskell.  This version of Hugs, Hugs 98, supports nearly all of
 the Haskell 98 specification, as well as a number of extensions.
 .
 The Haskell language is described by documents in the haskell-doc
 package.  Other libraries are documented in the ghc6-doc package.
Recommends: libhugs-alut,
            libhugs-cabal,
            libhugs-fgl,
            libhugs-glut,
            libhugs-haskell-src,
            libhugs-haxml,
            libhugs-hgl,
            libhugs-hunit,
            libhugs-mtl,
            libhugs-network,
            libhugs-openal,
            libhugs-opengl,
            libhugs-parsec,
            libhugs-quickcheck,
            libhugs-stm,
            libhugs-time,
            libhugs-unix,
            libhugs-x11,
            libhugs-xhtml,

Package: libhugs-alut-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         libhugs-openal,
         libhugs-opengl,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-alut,
Conflicts: libhugs-alut,
Description: Binding for the OpenAL Utility Toolkit
 A Haskell binding for the OpenAL Utility Toolkit, which makes
 managing of OpenAL contexts, loading sounds in various formats
 and creating waveforms very easy. For more information about the
 C library on which this binding is based, please see:
 <http://www.openal.org/openal_webstf/specs/alut.html>.
 .
 This is the version bundled with the interpreter.

Package: libhugs-base-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-base,
Conflicts: libhugs-base,
Description: Basic libraries
 This package contains the Prelude and its support libraries,
 and a large collection of useful libraries ranging from data
 structures to parsing combinators and debugging utilities.
 .
 This is the version bundled with the interpreter.

Package: libhugs-cabal-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-cabal,
Conflicts: libhugs-cabal,
Description: Framework for packaging Haskell software
 The Haskell Common Architecture for Building Applications and
 Libraries: a framework defining a common interface for authors to more
 easily build their Haskell applications in a portable way.
 .
 The Haskell Cabal is meant to be a part of a larger infrastructure
 for distributing, organizing, and cataloging Haskell libraries
 and tools.
 .
 This is the version bundled with the interpreter.

Package: libhugs-fgl-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         libhugs-mtl,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-fgl,
Conflicts: libhugs-fgl,
Description: Martin Erwig's Functional Graph Library
 This is the libhugs-fgl-bundled version that bundled with
 the interpreter.

Package: libhugs-glut-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         libhugs-opengl,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-glut,
Conflicts: libhugs-glut,
Description: Binding for the OpenGL Utility Toolkit
 A Haskell binding for the OpenGL Utility Toolkit, a window
 system independent toolkit for writing OpenGL programs. For more
 information about the C library on which this binding is based,
 please see: <http://www.opengl.org/resources/libraries/glut/>.
 .
 This is the version bundled with the interpreter.

Package: libhugs-haskell98-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-haskell98,
Conflicts: libhugs-haskell98,
Description: Compatibility with Haskell 98
 This package provides compatibility with the modules of Haskell
 98 and the FFI addendum, by means of wrappers around modules from
 the base package (which in many cases have additional features).
 However Prelude, Numeric and Foreign are provided directly by
 the base package.
 .
 This is the version bundled with the interpreter.

Package: libhugs-haskell-src-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         libhugs-haskell98,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-haskell-src,
Conflicts: libhugs-haskell-src,
Description: Manipulating Haskell source code
 Facilities for manipulating Haskell source code:
 an abstract syntax, lexer, parser and pretty-printer.
 .
 This is the version bundled with the interpreter.

Package: libhugs-haxml-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         libhugs-haskell98,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-haxml,
Conflicts: libhugs-haxml,
Description: Utilities for manipulating XML documents
 Haskell utilities for parsing, filtering, transforming and
 generating XML documents.
 .
 This is the version bundled with the interpreter.

Package: libhugs-hgl-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         libhugs-x11,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-hgl,
Conflicts: libhugs-hgl,
Description: Simple graphics library based on X11 or Win32
 A simple graphics library, designed to give the programmer access
 to most interesting parts of the Win32 Graphics Device Interface
 and X11 library without exposing the programmer to the pain and
 anguish usually associated with using these interfaces.
 .
 The library also includes a module Graphics.SOE providing the
 interface used in "The Haskell School of Expression", by Paul
 Hudak, cf <http://www.haskell.org/soe/>.
 .
 This is the version bundled with the interpreter.

Package: libhugs-hunit-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-hunit,
Conflicts: libhugs-hunit,
Description: Unit testing framework for Haskell
 HUnit is a unit testing framework for Haskell, inspired by the
 JUnit tool for Java, see: <http://www.junit.org>.
 .
 This is the version bundled with the interpreter.

Package: libhugs-mtl-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-mtl,
Conflicts: libhugs-mtl,
Description: Monad transformer library
 A monad transformer library, inspired by the paper "Functional
 Programming with Overloading and Higher-Order Polymorphism",
 by Mark P Jones (<http://www.cse.ogi.edu/~mpj/>), Advanced School
 of Functional Programming, 1995.
 .
 This is the version bundled with the interpreter.

Package: libhugs-network-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         libhugs-parsec,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-network,
Conflicts: libhugs-network,
Description: Networking-related facilities
 This is the libhugs-network-bundled version that bundled with the
 interpreter.

Package: libhugs-openal-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         libhugs-opengl,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-openal,
Conflicts: libhugs-openal,
Description: Binding to the OpenAL cross-platform 3D audio API
 A Haskell binding for the OpenAL cross-platform 3D audio API,
 appropriate for use with gaming applications and many other
 types of audio applications.  For more information about OpenAL,
 please see: <http://www.openal.org/>.
 .
 This is the version bundled with the interpreter.

Package: libhugs-opengl-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-opengl,
Conflicts: libhugs-opengl,
Description: Binding for the OpenGL graphics system
 A Haskell binding for the OpenGL graphics system (GL, version
 1.5) and its accompanying utility library (GLU, version 1.3).
 OpenGL is the industry's most widely used and supported 2D and 3D
 graphics application programming interface (API), incorporating
 a broad set of rendering, texture mapping, special effects, and
 other powerful visualization functions.  For more information
 about OpenGL, please see: <http://www.opengl.org/>.
 .
 This is the version bundled with the interpreter.

Package: libhugs-parsec-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-parsec,
Conflicts: libhugs-parsec,
Description: Monadic parser combinators
 Parsec is designed from scratch as an industrial-strength parser
 library.  It is simple, safe, well documented (on the package
 homepage), has extensive libraries and good error messages,
 and is also fast.
 .
 This is the version bundled with the interpreter.

Package: libhugs-quickcheck-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-quickcheck,
Conflicts: libhugs-quickcheck,
Description: Automatic testing of Haskell programs
 A library for testing Haskell programs automatically.
 The programmer provides a specification of the program, in
 the form of properties which functions should satisfy, and
 QuickCheck then tests that the properties hold in a large number
 of randomly generated cases.  Specifications are expressed in
 Haskell, using combinators defined in the QuickCheck library.
 QuickCheck provides combinators to define properties, observe
 the distribution of test data, and define test
 data generators.
 .
 This is the version bundled with the interpreter.

Package: libhugs-stm-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-stm,
Conflicts: libhugs-stm,
Description: Software Transactional Memory
 A modular composable concurrency abstraction.
 .
 This is the version bundled with the interpreter.

Package: libhugs-time-bundled
Architecture: any
Depends: hugs (= ${binary:Version}),
         libhugs-base,
         ${misc:Depends},
         ${shlibs:Depends},
Section: haskell
Provides: libhugs-time,
Conflicts: libhugs-time,
Description: time library
 This is the libhugs-time-bundled version that bundled with the
 interpreter.

=== debian/rules ===
#!/usr/bin/make -f

# Modified from /usr/share/doc/debhelper/examples/rules.multi2,
# incorporating various Hugs bits by
#	Antti-Juhani Kaijanaho <ajk@debian.org>
#	William Irwin <wli@debian.org>
#	Isaac Jones <ijones@syntaxpolice.org>

# This has to be exported to make some magic below work.
export DH_OPTIONS

%:
	dh $@

CONFIG_DIRS := . packages/network/ packages/Cabal/tests/HSQL/ \
	packages/ALUT/ packages/GLUT/ packages/OpenAL/ \
	packages/OpenGL/ src/unix/

CONFIG_OPTS := --prefix=/usr

# These are used for cross-compiling and for saving the configure
# script from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# Autoconf 2.52 and higher goes into crosscompiling mode when --host
# is specified, so only pass --host when it is necessary.
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  CONFIG_OPTS += --build=$(DEB_HOST_GNU_TYPE)
else
  CONFIG_OPTS += --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
endif

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  CONFIG_OPTS += --enable-debug
endif

build_stamp	= debian/build.stamp
install_stamp	= debian/install.stamp

# A file that should be present in a Hugs source tree
src_file	= src/hugs.c

build: $(build_stamp)
$(build_stamp):
	dh_testdir $(src_file)
	# get updated config.sub and config.guess
	for d in $(CONFIG_DIRS) ; do \
	    cp -f /usr/share/misc/config.sub /usr/share/misc/config.guess $(CURDIR)/$$d ;\
	done
	# touch so that patched configure does not trigger autoreconf
	touch configure.ac aclocal.m4 && touch configure
	CFLAGS='-g -Wall -fPIC -std=gnu89' $(MAKE) EXTRA_CONFIGURE_OPTS="$(CONFIG_OPTS)"
	touch $@

clean:
	dh_testdir $(src_file)
	$(RM) $(build_stamp) $(install_stamp)
	# remove updated config.sub and config.guess to keep diff.gz small
	for d in $(CONFIG_DIRS) ; do \
	    rm -f $(CURDIR)/$$d/config.sub $(CURDIR)/$$d/config.guess ;\
	done
	dh_clean
	$(MAKE) distclean

install: $(install_stamp)
$(install_stamp): DH_OPTIONS=
$(install_stamp): $(build_stamp)
	dh_testdir $(src_file)
	dh_prep
	dh_installdirs
	$(MAKE) DESTDIR="$(CURDIR)/debian/tmp" install_all_but_docs
	$(RM) debian/tmp/usr/lib/hugs/packages/*/LICENSE*
	$(RM) debian/tmp/usr/lib/hugs/packages/*/LICENCE*
	for d in $(filter packages/%,$(CONFIG_DIRS)) ; do \
	    if [ ! -d $(CURDIR)/debian/tmp/usr/lib/hugs/$$d ] && \
	       [ -f $(CURDIR)/$$d/config.log ] ; then \
		echo "*** begin $$d/config.log ***" ; \
		cat $(CURDIR)/$$d/config.log ; \
		echo "**** end $$d/config.log ****" ; \
	    fi ; \
	done
	dh_install --sourcedir=debian/tmp
	install -m 644 -D cpphs/docs/cpphs.1 debian/hugs/usr/share/man/man1/cpphs-hugs.1
	install -m 644 -D debian/libhugs-cabal-bundled.lintian-overrides \
		debian/libhugs-cabal-bundled/usr/share/lintian/overrides/libhugs-cabal-bundled
	touch $@

# This single target is used to build all the packages, all at once, or
# one at a time. So keep in mind: any options passed to commands here will
# affect _all_ packages. Anything you want to only affect one package
# should be put in another target, such as the install target.
binary-common:
	dh_testdir $(src_file)
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installman
	dh_strip
	dh_link
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture independant packages using the common target.
binary-indep: $(install_stamp)
# (Uncomment this next line if you have such packages.)
#	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: $(install_stamp)
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

# Any other binary targets build just one binary package at a time.
binary-%: $(install_stamp)
	$(MAKE) -f debian/rules DH_OPTIONS='-p$*' binary-common

binary: binary-indep binary-arch

.PHONY: build clean install binary binary-indep binary-arch binary-common update-config

=== debian/watch ===
version = 4
https://www.haskell.org/hugs/downloads/2006-09/hugs98-(.*)\.tar\.(?:gz|bz2|xz)
